#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <descrip.h>
#include <lib$routines.h>  /* lib$ services */
#include <ssdef.h>
#include <climsgdef.h>

#include "poprequest.h"

/* local definitions and prototypes */

#define CLI_VERB "poprequest " /* "define verb  CLI_VERB" in cld file */
int poprequest_cld(); /* module name in cld file */
int cli$dcl_parse();
int cli$present();
int cli$get_value();

void cli_dcl_parse(void)
{
   unsigned short int resultant_length = 0;
   char cmdlin[1024 + sizeof CLI_VERB], *cmdptr;
   int status;

   strcpy (cmdlin,CLI_VERB);
   cmdptr = &cmdlin[sizeof CLI_VERB - 1];
   lib$get_foreign(des(cmdptr, 1024), 
                   0, &resultant_length, 0);
   cmdptr[resultant_length]='\0';
   resultant_length += sizeof CLI_VERB - 1;
   status = cli$dcl_parse(des(cmdlin,resultant_length), 
                          poprequest_cld, 0,0,0);
   if (status != CLI$_NORMAL) 
   {
      fprintf (stderr,"error parsing command line: invalid arguments\n");
      usage();
   }
   return;
}

int cli_present (char *item)
{
   int status;
   status=cli$present(des(item,strlen(item)));
   if (status&1) 
     return 1; 
   else 
     return 0;
}

char *cli_get_value (char *item)
{
   static char buf[128];
   int status;
   unsigned short int length = 0;

   status = cli$get_value(desz(item),des(buf,sizeof buf - 1),&length);
   if(status&1) {
      buf[length] ='\0';
      return buf; 
   } else {
      return NULL;
   }
}


/* ======================================================================== */
/* returns the descriptor address of a zero terminated string.              */
/* DESCRIP.H is needed.                                                     */
/* ======================================================================== */
STR_DESCR * desz (char * String)
{
 return (String) ? des (String, strlen(String)) : NULL;
}

/* ======================================================================== */
/* returns the descriptor address of a fixed length string.                 */
/* remark: every nn invocation the same pointer is returned!                */
/*         nn is the number of elements of the array Descriptors[].         */
/* DESCRIP.H is needed.                                                     */
/* ======================================================================== */
STR_DESCR * des (char * buffer, size_t buflen)
{
static STR_DESCR Descriptors[] = {
            {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL},
            {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL},
            {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, NULL},
                                 };
static int num = 0;
STR_DESCR * ptr = NULL;

 if (buffer)
 {
   ptr = &Descriptors[num++];
   if (num >= (sizeof Descriptors / sizeof Descriptors[0])) num = 0;
   ptr->dsc$w_length  = buflen;
   ptr->dsc$a_pointer = buffer;
 }
 return ptr;
}


